<script lang="ts" setup>
import { ref, watch } from 'vue';
import { ChevronLgRight, ContinuousDelivery, CogCode, AutoScale } from 'slippers-ui/icons';

/**
 * Basic accordion component that can utilize slots and/or single strings. To minimize site-wide regressions, add any necessary styles from a parent component utilizing the :deep() selector.
 */

const icons = {
  ContinuousDelivery,
  CogCode,
  AutoScale,
};

const props = defineProps({
  data: {
    type: Object as () => {
      header?: string;
      content?: string;
      icon?: {
        config: {
          name: string;
          hexColor?: string;
        };
      };
      link?: {
        text: string;
        config: {
          url: string;
          dataGaName: string;
          dataGaLocation: string;
        };
      };
      config?: {
        id?: string; // Used for accessibility. Will fallback to 'header' string value if not provided.
        darkMode?: boolean; // Will change default font colors to work on a dark background
        analytics?: {
          dataGaName: string;
          dataGaLocation: string;
          dataToggleGroup?: string;
        };
      };
    },
    required: true,
  },
  isOpen: {
    type: Boolean,
    required: true,
    default: false,
  },
});

const emit = defineEmits(['toggleController']);

const openByDefault = ref(false);

watch(
  () => props.isOpen,
  (newValue) => {
    openByDefault.value = newValue;
  },
  { immediate: true },
);

const toggleAccordion = () => {
  openByDefault.value = !openByDefault.value;
  emit('toggleController', props.data.config?.id || props.data.header);
};
</script>

<template>
  <div :class="`accordion ${data.config?.darkMode ? 'on-dark-background' : ''}`">
    <button
      :id="`${(data?.config && data.config?.id) || data.header}-button`"
      class="accordion__summary"
      :aria-expanded="openByDefault"
      :aria-controls="`${data.config?.id || data.header}-panel`"
      :data-ga-name="data.config?.analytics?.dataGaName || 'accordion'"
      :data-ga-location="data.config?.analytics?.dataGaLocation || 'body'"
      :data-toggle-group="data.config?.analytics?.dataToggleGroup"
      :data-ga-toggle="openByDefault ? 'collapse' : 'expand'"
      @click="toggleAccordion"
    >
      <template v-if="$slots.header">
        <slot name="header" />
      </template>
      <template v-else>
        <div class="summary-header">
          <SlpIcon v-if="data.icon" :icon="icons[data.icon.config.name]" size="md" class="slp-mr-16" />{{ data.header }}
        </div>
      </template>
      <span class="accordion__icon" :class="{ 'accordion__icon--open': openByDefault }"></span>
    </button>
    <div
      v-show="openByDefault"
      :id="`${data.config?.id || data.header}-panel`"
      class="accordion__content-container"
      :aria-labelledby="`${data.config?.id || data.header}-button`"
    >
      <template v-if="$slots.content">
        <slot name="content" />
      </template>
      <template v-else>
        <div class="content" v-html="$md.render(data.content)" />
      </template>
      <SlpButton
        v-if="data.link"
        variant="tertiary"
        :href="data.link.config.url"
        :data-ga-name="data.link.config.dataGaName"
        :data-ga-location="data.link.config.dataGaLocation"
        :data-toggle-group="data.config?.analytics?.dataToggleGroup"
        :data-ga-toggle="openByDefault ? 'collapse' : 'expand'"
      >
        {{ data.link.text }} <SlpIcon :icon="ChevronLgRight" variant="product" hex-color="link-100" />
      </SlpButton>
    </div>
  </div>
</template>

<style lang="scss" scoped>
.accordion {
  color: $color-text-300;
  list-style-type: none;
  overflow: hidden;
  width: 100%;
  text-align: left;

  &.on-dark-background {
    color: $color-text-50;
  }

  &__summary {
    padding: 0;
    cursor: pointer;
    display: flex;
    justify-content: space-between;
    align-items: center;
    font-size: 23px;
    background: none;
    border: none;
    width: 100%;
    text-align: left;
    color: inherit;

    @media (max-width: $breakpoint-md) {
      padding: 16px 0;
    }
  }

  .summary-header {
    display: flex;
    @media (max-width: $breakpoint-md) {
      max-width: 85%;
    }
  }

  &__content-container {
    text-align: left;
    font-size: 16px;
  }

  .slp-btn {
    padding: $spacing-16 0;
    font-size: 14px;

    svg {
      height: 12px;
      width: 12px;
    }
  }

  &__icon {
    height: 18px;
    width: 18px;
    position: relative;
    transition: transform 0.4s ease-in-out;
    margin-left: $spacing-4;
    &--open {
      transform: rotate(90deg);
      &:after {
        opacity: 0;
      }
    }
    &:before,
    &:after {
      content: '';
      background-color: black;
      position: absolute;
      display: block;
    }
    &:before {
      height: 18px;
      width: 2px;
      left: 50%;
    }
    &:after {
      height: 18px;
      width: 2px;
      transform: rotate(-90deg);
      top: 50%;
      transform-origin: top;
      transition: opacity 0.3s ease-in-out;
    }
  }
}
</style>
